# generated by datamodel-codegen:
#   filename:  tmp7gd7dxlw.json
#   timestamp: 2024-09-23T19:23:54+00:00

from __future__ import annotations

from dataclasses import dataclass
from enum import Enum
from typing import Dict, List, Optional, Union


@dataclass
class AccessTokenResponse:
    access_token: str
    token_type: str
    expires_in: Optional[int] = None
    refresh_token: Optional[str] = None
    scope: Optional[str] = None


@dataclass
class AnnularCylinder:
    height: Optional[float] = None
    radius_outer: Optional[float] = None
    radius_inner: Optional[float] = None


@dataclass
class BilateralTolerance:
    value: Optional[float] = None
    minus: Optional[float] = None
    plus: Optional[float] = None


@dataclass
class BodyTokenV2AuthTokenPost:
    grant_type: str
    client_id: Optional[str] = None
    client_secret: Optional[str] = None
    assertion: Optional[str] = None


@dataclass
class Bore:
    radius: Optional[BilateralTolerance] = None
    depth: Optional[float] = None
    has_reamer: Optional[bool] = None


@dataclass
class Box:
    x: Optional[float] = None
    y: Optional[float] = None
    z: Optional[float] = None


@dataclass
class ColorDescription:
    hex: str
    label: str


@dataclass
class Counterbore:
    radius: Optional[float] = None
    depth: Optional[float] = None


@dataclass
class Countersink:
    radius: Optional[float] = None
    angle: Optional[float] = None


class ShapeEnum(Enum):
    TOOL_SHAPE_UNSPECIFIED = 'TOOL_SHAPE_UNSPECIFIED'
    TOOL_SHAPE_SQUARE_MILL = 'TOOL_SHAPE_SQUARE_MILL'
    TOOL_SHAPE_BALL_MILL = 'TOOL_SHAPE_BALL_MILL'
    TOOL_SHAPE_DRILL = 'TOOL_SHAPE_DRILL'


@dataclass
class Cut:
    radius: Optional[List[float]] = None
    volume: Optional[List[float]] = None
    shape: Optional[List[ShapeEnum]] = None
    is_rough: Optional[List[bool]] = None


@dataclass
class Cylinder:
    radius: Optional[float] = None
    height: Optional[float] = None


@dataclass
class Descriptions:
    color_id: Dict[str, ColorDescription]
    finish_id: Dict[str, ColorDescription]


@dataclass
class Error:
    code: Optional[str] = None
    message: Optional[str] = None


@dataclass
class ExceptionNotAllowed:
    code: str
    message: str


@dataclass
class ExceptionNotFound:
    code: str
    message: str


@dataclass
class ExceptionReturn:
    code: str
    message: str


class MethodIdEnum(Enum):
    FABRICATION_METHOD_UNSPECIFIED = 'FABRICATION_METHOD_UNSPECIFIED'
    FABRICATION_METHOD_FLAT = 'FABRICATION_METHOD_FLAT'
    FABRICATION_METHOD_BENT = 'FABRICATION_METHOD_BENT'
    FABRICATION_METHOD_ROLL = 'FABRICATION_METHOD_ROLL'
    FABRICATION_METHOD_MILL = 'FABRICATION_METHOD_MILL'
    FABRICATION_METHOD_COTS = 'FABRICATION_METHOD_COTS'
    FABRICATION_METHOD_ADD = 'FABRICATION_METHOD_ADD'
    FABRICATION_METHOD_TURN = 'FABRICATION_METHOD_TURN'
    FABRICATION_METHOD_MANUAL = 'FABRICATION_METHOD_MANUAL'


@dataclass
class FinishCombo:
    color_id: List[str]


class Strategy(Enum):
    FIXTURE_STRATEGY_UNSPECIFIED = 'FIXTURE_STRATEGY_UNSPECIFIED'
    FIXTURE_STRATEGY_VICE = 'FIXTURE_STRATEGY_VICE'
    FIXTURE_STRATEGY_CHUCK = 'FIXTURE_STRATEGY_CHUCK'
    FIXTURE_STRATEGY_HOLDDOWN = 'FIXTURE_STRATEGY_HOLDDOWN'


@dataclass
class FlatSettings:
    undersize_holes: Optional[float] = None


@dataclass
class Interval:
    min: Optional[float] = None
    max: Optional[float] = None


@dataclass
class JobCreation:
    task_id: str


@dataclass
class JobStatus:
    progress: float
    code: str
    message: str


@dataclass
class KFactor:
    material_id: Optional[str] = None
    radius_fraction: Optional[List[float]] = None
    k_factor: Optional[List[float]] = None


class MethodId(Enum):
    FABRICATION_METHOD_UNSPECIFIED = 'FABRICATION_METHOD_UNSPECIFIED'
    FABRICATION_METHOD_FLAT = 'FABRICATION_METHOD_FLAT'
    FABRICATION_METHOD_BENT = 'FABRICATION_METHOD_BENT'
    FABRICATION_METHOD_ROLL = 'FABRICATION_METHOD_ROLL'
    FABRICATION_METHOD_MILL = 'FABRICATION_METHOD_MILL'
    FABRICATION_METHOD_COTS = 'FABRICATION_METHOD_COTS'
    FABRICATION_METHOD_ADD = 'FABRICATION_METHOD_ADD'
    FABRICATION_METHOD_TURN = 'FABRICATION_METHOD_TURN'
    FABRICATION_METHOD_MANUAL = 'FABRICATION_METHOD_MANUAL'


@dataclass
class MaterialCombo:
    thickness_id: List[str]
    finish_id: List[str]


@dataclass
class MethodCombo:
    material_id: List[str]


@dataclass
class MillMachine:
    tool_pad: Optional[float] = None
    spindle_length: Optional[float] = None
    spindle_radius: Optional[float] = None
    spindle_pad: Optional[float] = None
    max_z_travel: Optional[float] = None
    extents: Optional[List[float]] = None
    feed_max: Optional[float] = None
    rpm_max: Optional[float] = None
    use_fast_inplane: Optional[bool] = None
    use_variables: Optional[bool] = None


class Detail(Enum):
    GPU_DETAIL_UNSPECIFIED = 'GPU_DETAIL_UNSPECIFIED'
    GPU_DETAIL_DRAFT = 'GPU_DETAIL_DRAFT'
    GPU_DETAIL_STANDARD = 'GPU_DETAIL_STANDARD'
    GPU_DETAIL_HIGH = 'GPU_DETAIL_HIGH'


@dataclass
class Money:
    currency: Optional[str] = None
    amount: Optional[int] = None


@dataclass
class NDArray:
    shape: Optional[List[int]] = None
    float64: Optional[List[float]] = None
    int64: Optional[List[int]] = None


@dataclass
class Operation:
    operation_id: Optional[str] = None
    price: Optional[Money] = None
    is_combinable: Optional[bool] = None
    duration: Optional[float] = None
    utilization: Optional[float] = None
    note: Optional[str] = None


@dataclass
class OrderCreateRequest:
    shop_id: str
    upload_ids: Optional[List[str]] = None


@dataclass
class OrderCreateResponse:
    order_id: str


class Event(Enum):
    ORDER_EVENT_UNSPECIFIED = 'ORDER_EVENT_UNSPECIFIED'
    ORDER_EVENT_CREATED = 'ORDER_EVENT_CREATED'
    ORDER_EVENT_SHARED = 'ORDER_EVENT_SHARED'


@dataclass
class OrderPrice:
    total: Optional[Money] = None
    lines: Optional[Money] = None
    setups: Optional[Money] = None
    shipping: Optional[Money] = None
    taxes: Optional[Money] = None
    discount: Optional[Money] = None


@dataclass
class OrderStripe:
    client_secret: str


@dataclass
class OrderUploadRequest:
    filename: str
    contentType: Optional[str]


@dataclass
class OrderUploadResponse:
    id: str
    url: List[str]
    dateExpiration: str
    dateCreation: str


@dataclass
class Outcome:
    is_completed: Optional[bool] = None
    is_success: Optional[bool] = None
    errors: Optional[List[Error]] = None
    quality: Optional[float] = None
    duration: Optional[float] = None


@dataclass
class PartConfiguration:
    part_id: Optional[str] = None
    method_id: Optional[MethodId] = None
    quantity: Optional[int] = None
    material_id: Optional[str] = None
    finish_id: Optional[str] = None
    color_id: Optional[str] = None
    thickness_id: Optional[str] = None
    posts: Optional[List[str]] = None
    expedite: Optional[str] = None
    notes: Optional[str] = None
    cots_id: Optional[str] = None


@dataclass
class Plane:
    origin: Optional[List[float]] = None
    normal: Optional[List[float]] = None
    area: Optional[float] = None
    height: Optional[float] = None
    extents: Optional[List[float]] = None
    volume: Optional[float] = None
    volume_support: Optional[float] = None


@dataclass
class Point3D:
    x: Optional[float] = None
    y: Optional[float] = None
    z: Optional[float] = None


@dataclass
class PostalAddress:
    address_id: Optional[str] = None
    country: Optional[str] = None
    region: Optional[str] = None
    city: Optional[str] = None
    postal_code: Optional[str] = None
    address_lines: Optional[List[str]] = None
    recipient: Optional[str] = None
    phone: Optional[str] = None
    email: Optional[str] = None
    latitude: Optional[float] = None
    longitude: Optional[float] = None
    place_id: Optional[str] = None


class Kind(Enum):
    POST_KIND_UNSPECIFIED = 'POST_KIND_UNSPECIFIED'
    POST_KIND_TAP = 'POST_KIND_TAP'
    POST_KIND_COUNTERSINK = 'POST_KIND_COUNTERSINK'
    POST_KIND_COUNTERBORE = 'POST_KIND_COUNTERBORE'
    POST_KIND_WELD = 'POST_KIND_WELD'
    POST_KIND_BORE = 'POST_KIND_BORE'
    POST_KIND_TOLERANCE = 'POST_KIND_TOLERANCE'


@dataclass
class RigidTransform:
    values: Optional[List[float]] = None


class Tag(Enum):
    SEGMENT_TAG_UNSPECIFIED = 'SEGMENT_TAG_UNSPECIFIED'
    SEGMENT_TAG_CUT = 'SEGMENT_TAG_CUT'
    SEGMENT_TAG_CUT_FINISH = 'SEGMENT_TAG_CUT_FINISH'
    SEGMENT_TAG_CUT_PLUNGE = 'SEGMENT_TAG_CUT_PLUNGE'
    SEGMENT_TAG_CUT_DRILL = 'SEGMENT_TAG_CUT_DRILL'
    SEGMENT_TAG_MOVE = 'SEGMENT_TAG_MOVE'
    SEGMENT_TAG_MOVE_SHORTCUT = 'SEGMENT_TAG_MOVE_SHORTCUT'
    SEGMENT_TAG_MOVE_LINK = 'SEGMENT_TAG_MOVE_LINK'
    SEGMENT_TAG_ERROR = 'SEGMENT_TAG_ERROR'
    SEGMENT_TAG_SENTINEL = 'SEGMENT_TAG_SENTINEL'


@dataclass
class Segment:
    start: Optional[Point3D] = None
    final: Optional[Point3D] = None
    angle: Optional[float] = None
    tag: Optional[Tag] = None
    tool_index: Optional[int] = None
    radius_override: Optional[float] = None


@dataclass
class SegmentStatistics:
    length: Optional[float] = None
    duration: Optional[float] = None
    tool_length: Optional[List[float]] = None
    tool_duration: Optional[List[float]] = None
    tool_changes: Optional[int] = None


class Kind1(Enum):
    STOCK_KIND_UNSPECIFIED = 'STOCK_KIND_UNSPECIFIED'
    STOCK_KIND_SHEET = 'STOCK_KIND_SHEET'
    STOCK_KIND_ROD = 'STOCK_KIND_ROD'
    STOCK_KIND_BAR = 'STOCK_KIND_BAR'


class Units(Enum):
    UNIT_SYSTEM_UNSPECIFIED = 'UNIT_SYSTEM_UNSPECIFIED'
    UNIT_SYSTEM_MKS = 'UNIT_SYSTEM_MKS'
    UNIT_SYSTEM_IPS = 'UNIT_SYSTEM_IPS'


@dataclass
class Thread:
    is_imperial: Optional[bool] = None
    description: Optional[str] = None
    pitch: Optional[float] = None
    radius_minor: Optional[float] = None
    radius_major: Optional[float] = None


@dataclass
class Timestamp:
    seconds: Optional[float] = None


class Shape(Enum):
    TOOL_SHAPE_UNSPECIFIED = 'TOOL_SHAPE_UNSPECIFIED'
    TOOL_SHAPE_SQUARE_MILL = 'TOOL_SHAPE_SQUARE_MILL'
    TOOL_SHAPE_BALL_MILL = 'TOOL_SHAPE_BALL_MILL'
    TOOL_SHAPE_DRILL = 'TOOL_SHAPE_DRILL'


@dataclass
class ToolParameters:
    material_id: Optional[str] = None
    surface_feet_per_minute: Optional[Interval] = None
    inch_per_tooth: Optional[Interval] = None
    maximum_rpm: Optional[float] = None
    radial_depth_of_cut: Optional[float] = None
    is_carbide: Optional[bool] = None
    flutes: Optional[int] = None
    use_rough: Optional[bool] = None
    use_finish: Optional[bool] = None


@dataclass
class UploadRequest:
    filename: str


@dataclass
class UploadResponse:
    file_id: str
    upload_url: str
    expiration: str


@dataclass
class ValidationError:
    loc: List[Union[str, int]]
    msg: str
    type: str


@dataclass
class Weld:
    length: Optional[float] = None


@dataclass
class BentRegions:
    wkt: Optional[str] = None
    to_3d: Optional[NDArray] = None


@dataclass
class BentSettings:
    k_factor: Optional[List[KFactor]] = None


@dataclass
class BoundingBox3D:
    lower: Optional[Point3D] = None
    upper: Optional[Point3D] = None


@dataclass
class Combinations:
    finish_id: Dict[str, FinishCombo]
    material_id: Dict[str, MaterialCombo]
    method_id: Dict[str, MethodCombo]


@dataclass
class CotsMatch:
    cots_id: Optional[str] = None
    supplier_id: Optional[str] = None
    link: Optional[str] = None
    title: Optional[str] = None
    pack_price: Optional[Money] = None
    pack_size: Optional[int] = None
    weight_lb: Optional[float] = None
    component_id: Optional[str] = None


@dataclass
class Drill:
    radius: Optional[float] = None
    depth: Optional[List[float]] = None
    origins: Optional[NDArray] = None
    normal: Optional[List[float]] = None
    thru: Optional[bool] = None
    labels: Optional[List[str]] = None


@dataclass
class FileBlob:
    file_id: Optional[str] = None
    name: Optional[str] = None
    data: Optional[bytes] = None
    url: Optional[str] = None
    url_expires: Optional[Timestamp] = None
    mediatype: Optional[str] = None
    sha256: Optional[str] = None


@dataclass
class GeometrySummary:
    geom_id: Optional[str] = None
    node_id: Optional[List[str]] = None
    name: Optional[str] = None
    preview: Optional[FileBlob] = None


@dataclass
class HTTPValidationError:
    detail: Optional[List[ValidationError]] = None


@dataclass
class ManualFabrication:
    outcome: Optional[Outcome] = None
    drawing: Optional[FileBlob] = None
    defaults: Optional[PartConfiguration] = None


@dataclass
class Mesh:
    blob: Optional[FileBlob] = None


@dataclass
class OrderEventLog:
    time: Optional[Timestamp] = None
    event: Optional[Event] = None


@dataclass
class Postprocess:
    post_id: Optional[str] = None
    geom_id: Optional[str] = None
    method_id: Optional[MethodId] = None
    kind: Optional[Kind] = None
    group: Optional[str] = None
    description: Optional[str] = None
    markers: Optional[NDArray] = None
    is_default: Optional[bool] = None
    thread: Optional[Thread] = None
    countersink: Optional[Countersink] = None
    counterbore: Optional[Counterbore] = None
    weld: Optional[Weld] = None
    bore: Optional[Bore] = None


@dataclass
class Scene:
    neutral: Optional[FileBlob] = None
    original: Optional[FileBlob] = None
    name: Optional[str] = None
    geometries: Optional[List[GeometrySummary]] = None
    preview: Optional[FileBlob] = None


@dataclass
class ShippingParcel:
    ship_from: Optional[PostalAddress] = None
    ship_to: Optional[PostalAddress] = None
    line_id: Optional[List[str]] = None
    extents: Optional[List[float]] = None
    weight: Optional[float] = None
    provider: Optional[str] = None
    provider_id: Optional[str] = None
    label: Optional[FileBlob] = None
    tracking_url: Optional[str] = None


@dataclass
class Stock:
    stock_id: Optional[str] = None
    material_id: Optional[str] = None
    supplier_id: Optional[str] = None
    supplier_pin: Optional[str] = None
    supplier_link: Optional[str] = None
    price: Optional[Money] = None
    expiry: Optional[Timestamp] = None
    quantity: Optional[int] = None
    kind: Optional[Kind1] = None
    extents: Optional[List[float]] = None
    units: Optional[Units] = None


@dataclass
class Tool:
    shape: Optional[Shape] = None
    index: Optional[int] = None
    parameters: Optional[List[ToolParameters]] = None
    radius: Optional[float] = None
    length_cut: Optional[float] = None
    length_total: Optional[float] = None
    suppliers: Optional[List[CotsMatch]] = None
    speed_feed: Optional[float] = None
    speed_rpm: Optional[float] = None


@dataclass
class ToolPlane:
    transform: Optional[RigidTransform] = None
    limits: Optional[BoundingBox3D] = None
    levels: Optional[List[float]] = None


@dataclass
class TurnFabrication:
    outcome: Optional[Outcome] = None
    posts: Optional[List[Postprocess]] = None
    drawing: Optional[FileBlob] = None
    defaults: Optional[PartConfiguration] = None
    height: Optional[float] = None
    diameter: Optional[float] = None
    volume: Optional[float] = None
    inner_diameter: Optional[float] = None
    profile: Optional[FileBlob] = None


@dataclass
class AddFabrication:
    outcome: Optional[Outcome] = None
    posts: Optional[List[Postprocess]] = None
    drawing: Optional[FileBlob] = None
    defaults: Optional[PartConfiguration] = None
    planes: Optional[List[Plane]] = None


@dataclass
class Brand:
    brand_id: Optional[str] = None
    name: Optional[str] = None
    description: Optional[str] = None
    logo: Optional[FileBlob] = None
    address: Optional[PostalAddress] = None
    display_units: Optional[str] = None


@dataclass
class CotsFabrication:
    outcome: Optional[Outcome] = None
    posts: Optional[List[Postprocess]] = None
    drawing: Optional[FileBlob] = None
    defaults: Optional[PartConfiguration] = None
    matches: Optional[List[CotsMatch]] = None
    cylinder: Optional[Cylinder] = None
    annular: Optional[AnnularCylinder] = None


@dataclass
class FlatFabrication:
    outcome: Optional[Outcome] = None
    posts: Optional[List[Postprocess]] = None
    drawing: Optional[FileBlob] = None
    defaults: Optional[PartConfiguration] = None
    perimeter: Optional[float] = None
    holes: Optional[List[float]] = None
    extents: Optional[List[float]] = None
    area: Optional[float] = None
    rapids: Optional[float] = None
    thickness: Optional[float] = None
    flattened: Optional[FileBlob] = None
    to_flattened: Optional[RigidTransform] = None


@dataclass
class Geometry:
    box: Optional[Box] = None
    cylinder: Optional[Cylinder] = None
    annular: Optional[AnnularCylinder] = None
    mesh: Optional[Mesh] = None
    transform: Optional[RigidTransform] = None


@dataclass
class LinePrice:
    part_id: Optional[str] = None
    method_id: Optional[MethodId] = None
    shop_id: Optional[str] = None
    address_id: Optional[str] = None
    unit: Optional[Money] = None
    total: Optional[Money] = None
    quantity: Optional[int] = None
    mass: Optional[float] = None
    extents: Optional[List[float]] = None
    stock: Optional[Stock] = None
    operations: Optional[List[Operation]] = None
    outcome: Optional[Outcome] = None
    description: Optional[str] = None


@dataclass
class MillPreprocess:
    directions: Optional[NDArray] = None
    stock: Optional[Stock] = None
    stock_geometry: Optional[Geometry] = None
    mesh: Optional[Geometry] = None
    drills: Optional[List[Drill]] = None
    collision: Optional[List[Geometry]] = None


@dataclass
class MillSettings:
    material_id: Optional[str] = None
    machine: Optional[MillMachine] = None
    tools: Optional[List[Tool]] = None
    detail: Optional[Detail] = None
    return_volume: Optional[bool] = None
    return_gcode: Optional[bool] = None
    return_plan: Optional[bool] = None
    skip_fixture_collisions: Optional[bool] = None
    default_radial_depth_of_cut: Optional[float] = None
    default_skip_ball: Optional[bool] = None
    plane_normals: Optional[NDArray] = None
    max_directions: Optional[int] = None
    skip_prune: Optional[bool] = None
    preprocess: Optional[MillPreprocess] = None


@dataclass
class OrderLine:
    line_id: Optional[str] = None
    config: Optional[PartConfiguration] = None
    price: Optional[LinePrice] = None


@dataclass
class RollFabrication:
    outcome: Optional[Outcome] = None
    posts: Optional[List[Postprocess]] = None
    drawing: Optional[FileBlob] = None
    defaults: Optional[PartConfiguration] = None
    height: Optional[float] = None
    diameter: Optional[float] = None
    flat: Optional[FlatFabrication] = None


@dataclass
class SegmentPath:
    segments: Optional[List[Segment]] = None
    tools: Optional[List[Tool]] = None
    plane: Optional[ToolPlane] = None
    stats: Optional[SegmentStatistics] = None


@dataclass
class Shop:
    shop_id: str
    brand: Brand
    combinations: Combinations
    descriptions: Descriptions


@dataclass
class BentFabrication:
    outcome: Optional[Outcome] = None
    posts: Optional[List[Postprocess]] = None
    drawing: Optional[FileBlob] = None
    defaults: Optional[PartConfiguration] = None
    bend_count: Optional[int] = None
    bend_setups: Optional[int] = None
    bend_k: Optional[List[float]] = None
    bend_angle: Optional[List[float]] = None
    bend_radii: Optional[List[float]] = None
    flat: Optional[FlatFabrication] = None
    regions: Optional[BentRegions] = None


@dataclass
class FabricationSettings:
    method_id: Optional[List[MethodIdEnum]] = None
    mill: Optional[MillSettings] = None
    bent: Optional[BentSettings] = None
    flat: Optional[FlatSettings] = None


@dataclass
class Fixture:
    strategy: Optional[Strategy] = None
    collision: Optional[Geometry] = None
    normal: Optional[List[float]] = None


@dataclass
class GeometryRequest:
    source: Optional[FileBlob] = None
    source_units: Optional[str] = None
    brand: Optional[Brand] = None
    settings: Optional[FabricationSettings] = None
    return_previews: Optional[bool] = None
    return_interference: Optional[bool] = None
    return_proprietary: Optional[bool] = None


@dataclass
class MillPlan:
    part: Optional[Geometry] = None
    stock: Optional[Geometry] = None
    paths: Optional[List[SegmentPath]] = None


@dataclass
class MillFabrication:
    outcome: Optional[Outcome] = None
    posts: Optional[List[Postprocess]] = None
    drawing: Optional[FileBlob] = None
    defaults: Optional[PartConfiguration] = None
    stock: Optional[Stock] = None
    fixtures: Optional[List[Fixture]] = None
    cuts: Optional[List[Cut]] = None
    volume: Optional[FileBlob] = None
    gcode: Optional[List[FileBlob]] = None
    plan: Optional[MillPlan] = None
    pre: Optional[MillPreprocess] = None
    machine: Optional[MillMachine] = None


@dataclass
class PartFabrication:
    part_id: Optional[str] = None
    geom_id: Optional[str] = None
    geom_name: Optional[str] = None
    outcome: Optional[Outcome] = None
    extents: Optional[List[float]] = None
    flat: Optional[FlatFabrication] = None
    bent: Optional[BentFabrication] = None
    roll: Optional[RollFabrication] = None
    mill: Optional[MillFabrication] = None
    cots: Optional[CotsFabrication] = None
    add: Optional[AddFabrication] = None
    turn: Optional[TurnFabrication] = None
    manual: Optional[ManualFabrication] = None


@dataclass
class GeometryResponse:
    outcome: Optional[Outcome] = None
    analysis: Optional[List[PartFabrication]] = None
    scene: Optional[Scene] = None


@dataclass
class Order:
    order_id: Optional[str] = None
    account_id: Optional[str] = None
    shop_id: Optional[str] = None
    state: Optional[List[OrderEventLog]] = None
    parts: Optional[List[PartFabrication]] = None
    lines: Optional[List[OrderLine]] = None
    models: Optional[List[Scene]] = None
    shipping: Optional[PostalAddress] = None
    billing: Optional[PostalAddress] = None
    parcels: Optional[List[ShippingParcel]] = None
    total: Optional[OrderPrice] = None
    date_modified: Optional[Timestamp] = None
    date_created: Optional[Timestamp] = None
